/*
   Billy the Kid (packet.c)
   "..a python module to do all kinds of raw network shit..."

   by Gorny (gorny0@zonnet.nl)
   http://gorny.cjb.net
*/

#include "wrap.h"
#include "packet.h"

/* never seen this routine before? get a life! >;) */
unsigned short
in_cksum (unsigned short *ptr, int nbytes)
{
  register long sum;
  u_short oddbyte;
  register u_short answer;
  sum = 0;
  while (nbytes > 1)
    {
      sum += *ptr++;
      nbytes -= 2;
    }
  if (nbytes == 1)
    {
      oddbyte = 0;
      *((u_char *) & oddbyte) = *(u_char *) ptr;
      sum += oddbyte;
    }
  sum = (sum >> 16) + (sum & 0xffff);
  sum += (sum >> 16);
  answer = ~sum;
  return (answer);
}

void
fill_ip_headers(btk_object *self) 
{
	u_long length = strlen(self->data);
	struct in_addr srcip, dstip;
        srcip.s_addr = inet_addr(self->srcip);
        dstip.s_addr = inet_addr(self->dstip);	

        self->pseudo->saddr = srcip.s_addr;
       	self->pseudo->daddr = dstip.s_addr;
        self->pseudo->protocol=self->protocol;
        self->pseudo->length = htons(sizeof (struct tcphdr)+ length);

       	self->iph->ip_src = srcip;
       	self->iph->ip_dst = dstip;
        self->iph->ip_hl = 5;        /* header length */
        self->iph->ip_v = 4;         /* version */
	self->iph->ip_len = sizeof(struct ip) + sizeof(struct tcphdr) + length;
	self->iph->ip_p = (u_int8_t)self->protocol;

	if(self->id) self->iph->ip_id = self->id;
        else self->iph->ip_id = _IP_ID;      /* identification */

	if(self->off) self->iph->ip_off = self->off;
	else self->iph->ip_off = _IP_OFF;
	
	if(self->tos) self->iph->ip_tos = self->tos;
	else self->iph->ip_tos = _IP_TOS;

	if(self->ttl) self->iph->ip_ttl = self->ttl;
	else self->iph->ip_ttl = _IP_TTL;
        self->iph->ip_p = (u_int8_t)self->protocol;
}

void
fill_tcp_headers(btk_object *self)
{
	u_long length = strlen(self->data);
	fill_ip_headers(self); /* don't forget the ip-headers */

	self->tcph->th_x2 = 0;
        self->tcph->th_off = 5;
        self->tcph->th_flags = self->flags;
        self->tcph->th_sport = htons(self->srcport);
        self->tcph->th_dport = htons(self->dstport);

	if(self->win) self->tcph->th_win = self->win;
	else self->tcph->th_win = _TCP_WIN;

	if(self->urp) self->tcph->th_urp = self->urp;
	else self->tcph->th_urp = _TCP_URP;

	if(self->ack) self->tcph->th_ack = self->ack;
	else self->tcph->th_ack = _TCP_ACK;

	if(self->seq) self->tcph->th_seq=(u_int16_t)self->seq;
	else self->tcph->th_seq = random();
	
	/* copy data to packet.. */
        if (self->data && length)
                memcpy(self->packet + sizeof(struct ip) + sizeof(struct tcphdr)+
                       sizeof(struct pseudo), self->data, length);

	/* let's checksumm the packet */
        self->tcph->th_sum = in_cksum((unsigned short *) self->pseudo, length +
                                sizeof(struct pseudo)+sizeof(struct tcphdr));
	memcpy(self->pseudo, self->tcph,sizeof(struct tcphdr)+length);
}

void
fill_udp_headers(btk_object *self)
{
	fill_ip_headers(self); /* don't forget the ip-headers */
}

void
fill_icmp_headers(btk_object *self)
{
	fill_ip_headers(self); /* don't forget the ip-headers */
}
