/*
   Billy the Kid (packet.h)
   "..a python module to do all kinds of raw network shit..."

   by Gorny (gorny0@zonnet.nl)
   http://gorny.cjb.net
*/

#define __FAVOR_BSD
#include <arpa/inet.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <sys/socket.h>

/* all default values filled in by packet.c
 if not user-defined! */
#define _IP_ID	3912
#define _IP_TOS  0
#define _IP_OFF	0
#define _IP_TTL  40
#define _TCP_WIN 65535
#define _TCP_ACK 0
#define _TCP_URP 0

/* TCP flags */
#define FIN        0x01
#define SYN        0x02
#define RST        0x04
#define PUSH       0x08
#define ACK        0x10
#define URG        0x20
#define CWR	   0x40
#define ECN	   0x80

/* Supported protocols */
#define TCP 6
#define UDP 17
#define ICMP 1

/* pseudo header struct */
struct pseudo {
        u_long saddr;
        u_long daddr;
        u_char zero;
        u_char protocol;
        u_short length;
};

/* all packet.c function prototypes */
unsigned short in_cksum (unsigned short *, int);
void fill_ip_headers(btk_object *self);
void fill_tcp_headers(btk_object *self);
void fill_udp_headers(btk_object *self);
void fill_icmp_headers(btk_object *self);
